#include <process.h>
#include <stdio.h>
#include "bt.h"
#include "error.h"
//#include "filter.h"
#include "btrieve.hpp"
#include "btop.h"
#include <conio.h>
#include "bcalls.h"
#ifndef BOOL
   #define BOOL short
#endif

#include "bcalls.h"
#include "errorwin.h"


#define BTRCL   this->btrvsyscall
#define CHECKERR()      this->error(__FILE__,__LINE__)
#define SETOP(OP)          this->btstr.OPCode=OP
#define SETKB(buf)      memcpy(this->btstr.Keybuffer,buf,MAXKEYLENGTH);
#define SETKN(num)      this->btstr.Keynumber = num
#define SETDB(buf)      memcpy(this->btstr.Databuffer,buf,MAXRECORDLENGTH)
#define SETDBL(num)     this->btstr.Databufferlength = num


// This structure is used if BTRIEVE is running as an NLM
struct
{
 char        netAddress[ 12 ];
 short        MyId;
 short        ClientID;
} Userstruct = { {0,0,0,0,0,0,0,0,0,0,0,0 }, 'BO', 0 };



BOOL Databasefile::DoDataExchange(char direction)
        {
        return TRUE;
        }




BOOL Databasefile::btrvsyscall()
        {
        this->btstr.result =0;
        #ifndef FORNETWARE
        	btstr.result = BTR(btstr.OPCode,btstr.posblock,btstr.Databuffer,\
                &btstr.Databufferlength,btstr.Keybuffer,btstr.Keynumber);
        #else
                btstr.result =BTR(btstr.OPCode,btstr.posblock,btstr.Databuffer,\
                (short *)&btstr.Databufferlength,btstr.Keybuffer,btstr.Keynumber,(struct Userstruct *)&Userstruct);
        #endif        
        if (btstr.result == 0)
                return TRUE;
        return FALSE;
        }

BOOL Databasefile::error(char *file,short line)
        {
                char buffer[100];
                
        // Process Fatal Errors
        if (this->btstr.result ==0)
                return TRUE;
        if (this->btstr.result == 9)
                return FALSE;  // EOF BOF
        if (this->btstr.result == 4)
                return FALSE;  // Keyval not found

        // Strange Error occured        
        sprintf(buffer,"%c\nError in Database:%s\nFile:%s Line:%d Result:%d: %s",7,Databasename,file,line,btstr.result,errorarray[btstr.result]);
                  printf(buffer);
        this->ALLCHLOR=FALSE;
        return FALSE;
        }


Databasefile::Databasefile(char *Filename,BOOL RO_Mode,short Index)
                  {
                  // Init
                  long Records = 0;
                  ALLCHLOR=FALSE;
                  hasRecords = FALSE;
                  memset((void *)&this->btstr,0,sizeof(BT_STRUCT));
                  memset(&file,0,sizeof(file));
                  this->btstr.Databufferlength=MAXRECORDLENGTH;
                  strcpy(this->Databasename,Filename);
                  strcpy(btstr.Databasefilename,Filename);

                  btstr.Keynumber = -1; // open ACCEL Mode
                  btstr.Recordpointer = btstr.Databuffer;

                  SETDBL(MAXRECORDLENGTH);
                  SETOP(OPEN);
                  SETKB(Filename);
                  //SETKN(Index);
                  BTRCL();
                  CHECKERR();
                  SETKN(Index);
                  if (this->btstr.result == 0)
                                         {
                                         ALLCHLOR=TRUE;
                                         this->Fileopen = TRUE;
                                         this->Reclength(&reclength);
                                         this->GetFirst();
                                         this->Stat();
                                         this->RecCount(&Records);
                                         if (Records>0)
                                                                hasRecords = TRUE;
                                         this->GetFirst();
                                         }
                  else
                                        {
               this->Fileopen = FALSE;
               ALLCHLOR=FALSE;
               return;
               }
        ALLCHLOR=TRUE;
        }


Databasefile::~Databasefile(void)
        {
        if (this->Fileopen)
                {
                SAVEBT;
                SETOP(CLOSE);
                BTRCL();
                CHECKERR();
                }
        }
